//+------------------------------------------------------------------+
//|                                            Parallel Channels.mq4 |
//|                                "Copyright  2005, Rustem Bigeev" |
//|                                             http://www.parch.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Rustem Bigeev"
#property link      "http://www.parch.ru/"

#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 DarkViolet
#property indicator_color2 DarkViolet
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 DimGray
#property indicator_color8 DimGray

//---- input parameters
extern int BasePeriod=120;
extern int ShiftChannel=0;
extern int ShiftATRPeriod=1;
int WightChannel=0;


//---- indicator buffers
double ExtVioletBufferUp[];
double ExtVioletBufferLw[];
double ExtRedBufferUp[];
double ExtRedBufferLw[];
double ExtBlueBufferUp[];
double ExtBlueBufferLw[];
double ExtGrayBufferUp[];
double ExtGrayBufferLw[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//----
   SetIndexStyle(0,DRAW_LINE,2);
   SetIndexBuffer(0,ExtVioletBufferUp);
   SetIndexShift(0,ShiftChannel);
   SetIndexLabel(0,"Violet Channel High");
//----
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexBuffer(1,ExtVioletBufferLw);
   SetIndexShift(1,ShiftChannel);
   SetIndexLabel(1,"Violet Channel Low");
//----
   SetIndexStyle(2,DRAW_LINE,2);
   SetIndexBuffer(2,ExtRedBufferUp);
   SetIndexShift(2,ShiftChannel);
   SetIndexLabel(2,"Red Channel High");
//----
   SetIndexStyle(3,DRAW_LINE,2);
   SetIndexBuffer(3,ExtRedBufferLw);
   SetIndexShift(3,ShiftChannel);
   SetIndexLabel(3,"Red Channel Low");
//----
   SetIndexStyle(4,DRAW_LINE,2);
   SetIndexBuffer(4,ExtBlueBufferUp);
   SetIndexShift(4,ShiftChannel);
   SetIndexLabel(4,"Blue Channel High");
//----
   SetIndexStyle(5,DRAW_LINE,2);
   SetIndexBuffer(5,ExtBlueBufferLw);
   SetIndexShift(5,ShiftChannel);
   SetIndexLabel(5,"Blue Channel Low");
//----
   SetIndexStyle(6,DRAW_LINE,2);
   SetIndexBuffer(6,ExtGrayBufferUp);
   SetIndexShift(6,ShiftChannel);
   SetIndexLabel(6,"Gray Channel High");
//----
   SetIndexStyle(7,DRAW_LINE,2);
   SetIndexBuffer(7,ExtGrayBufferLw);
   SetIndexShift(7,ShiftChannel);
   SetIndexLabel(7,"Gray Channel Low");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Bigeev Rustem    -  Parallel Channels
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
      WightChannel=iATR(NULL,0,BasePeriod*ShiftATRPeriod,0)*2/Point;
      ExtVioletBufferUp[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)+WightChannel*Point;
      ExtVioletBufferLw[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)-WightChannel*Point;
      ExtRedBufferUp[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)+WightChannel*2*Point;
      ExtRedBufferLw[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)-WightChannel*2*Point;
      ExtBlueBufferUp[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)+WightChannel*3*Point;
      ExtBlueBufferLw[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)-WightChannel*3*Point;
      ExtGrayBufferUp[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)+WightChannel*4*Point;
      ExtGrayBufferLw[i]=iMA(NULL,0,BasePeriod,ShiftChannel,MODE_SMA,PRICE_CLOSE,i)-WightChannel*4*Point;
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

